import scipy.io as sio
import sys
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.axes_grid1.inset_locator import inset_axes
from IPython import display
plt.rcParams.update({'font.size': 22})
plt.rcParams.update({'figure.max_open_warning': 0})

plt.interactive(True)

viscos=1/1000


# makes sure figures are updated when using ipython
display.clear_output(wait=True)

datax= np.loadtxt("x2d.dat")
x=datax[0:-1]
ni=int(datax[-1])
datay= np.loadtxt("y2d.dat")
y=datay[0:-1]
nj=int(datay[-1])

x2d=np.zeros((ni+1,nj+1))
y2d=np.zeros((ni+1,nj+1))

x2d=np.reshape(x,(ni+1,nj+1))
y2d=np.reshape(y,(ni+1,nj+1))

# compute cell centers
xp2d=0.25*(x2d[0:-1,0:-1]+x2d[0:-1,1:]+x2d[1:,0:-1]+x2d[1:,1:])
yp2d=0.25*(y2d[0:-1,0:-1]+y2d[0:-1,1:]+y2d[1:,0:-1]+y2d[1:,1:])

y=yp2d[1,:]


u2d=np.load('u2d_saved.npy')
p2d=np.load('p2d_saved.npy')
v2d=np.load('v2d_saved.npy')

# load u vs iteration
u_iter= np.loadtxt("u-iter-history.dat")

iter=u_iter[:,0]
u5=u_iter[:,1]
u10=u_iter[:,2]
u20=u_iter[:,3]
u30=u_iter[:,4]
u40=u_iter[:,5]
u50=u_iter[:,6]


# load u vs iteration from CALC
u_iter_calc= np.loadtxt("u_iter_calc.dat")

iter_calc=u_iter_calc[:,0]
u5_calc=u_iter_calc[:,1]
u10_calc=u_iter_calc[:,2]
u20_calc=u_iter_calc[:,3]
u30_calc=u_iter_calc[:,4]
u40_calc=u_iter_calc[:,5]
u50_calc=u_iter_calc[:,6]


# load CALC-BFC data
data=np.genfromtxt("uvy.dat",comments="%")

u_calc=data[:,0]
v_calc=data[:,1]
y_calc=data[:,2]


########################################## plot u along x=0.5
fig1,ax1 = plt.subplots()
plt.subplots_adjust(left=0.20,bottom=0.20)
i=29
u05=0.5*(u2d[i,:]+u2d[i+1,:])
plt.plot(u05,y,'b-')
plt.plot(u_calc,y_calc,'r--')
plt.ylabel("$y$")
plt.xlabel("$U$")
plt.axis([-0.4,1,0,1])
plt.savefig('u_lid.png')


########################################## plot u vs. iteration 
fig1,ax1 = plt.subplots()
plt.subplots_adjust(left=0.25,bottom=0.20)
plt.plot(iter,u5,'b-')
plt.plot(iter,u10,'r-')
plt.plot(iter,u20,'k-')
plt.plot(iter,u30,'b--')
plt.plot(iter,u40,'r--')
plt.plot(iter,u50,'k--')
plt.ylabel("$U$")
plt.xlabel("iteration")
plt.savefig('u_iteration.png')


########################################## plot u vs. iteration  for CALC
fig1,ax1 = plt.subplots()
plt.subplots_adjust(left=0.25,bottom=0.20)
plt.plot(iter_calc,u5_calc,'b-')
plt.plot(iter_calc,u10_calc,'r-')
plt.plot(iter_calc,u20_calc,'k-')
plt.plot(iter_calc,u30_calc,'b--')
plt.plot(iter_calc,u40_calc,'r--')
plt.plot(iter_calc,u50_calc,'k--')
plt.ylabel("$U$")
plt.xlabel("iteration calc")
plt.savefig('u_iteration_calc.png')

