
def modify_init(u2d,v2d,k2d,om2d,vis2d):
   
# set inlet field in entre domain
#  u2d=np.repeat(u_bc_west[None,:], repeats=ni, axis=0)
   u2d=np.ones((ni,nj))
   k2d=0.1*np.ones((ni,nj))
   L=0.1
   om2d=k2d**0.5/L

   vis2d=k2d/om2d+viscos

   return u2d,v2d,k2d,om2d,vis2d

def modify_inlet():

   return u_bc_west,v_bc_west,k_bc_west,om_bc_west,u2d_face_w,convw

def modify_conv(convw,convs):

   return convw,convs

def modify_u(su2d,sp2d):

   global flowin,xpforce

   global flowin,xpforce

   if iter == 0:
      xpforce=np.ones(maxit)*0.012
      flowin=np.ones(maxit)
#     if restart:
#       force_flow= np.loadtxt("force-history.dat")
#       force=force_flow[:,0]
#       xpforce=force[-1]*np.ones(maxit)

   flow=np.sum(convw[0,:])

   flowin[iter]=flow
   flowin_target=np.sum(areaw[-1,:])

   if iter > 1:

     factor=1.e-5/0.0005
     xpforce[iter]=xpforce[iter-1]+factor*(flowin_target+flowin[iter-1]-2.*flowin[iter])
     if abs(xpforce[iter]-xpforce[iter-1]) < 0.000001:
        xpforce[iter]=xpforce[iter-1]

   dpdx=-xpforce[iter]
   su2d=su2d-dpdx*vol

# we know that for this flow the wall shear stress mustt be equal to one (since the driving pressure
# gradient is equal to one). We print it every iteration to see if it is one. When it reaches one it is
# a good indicator that the flow has converged

   tauw_south=viscos*np.sum(as_bound*u2d[:,0])/x2d[-1,0]
   tauw_north=viscos*np.sum(an_bound*u2d[:,-1])/x2d[-1,0]

   print(f"{'flow: '}{flow:.3f},{'flowin[iter]: '}{flowin[iter]:.3f},{'flowin[iter-1]: '}{flowin[iter-1]:.3f}")

   print(f"{'dpdx: '}{dpdx:.3f},{'tau wall, south: '}{tauw_south:.3f},{'tau wall, north: '}{tauw_north:.3f}")

   if iter == 0:
      np.savetxt('u-iter.dat', np.c_[u2d[0,3],u2d[0,11],u2d[0,22],u2d[0,38]])
      np.savetxt('k-iter.dat', np.c_[k2d[0,3],k2d[0,11],k2d[0,22],k2d[0,38]])
      np.save('dpdx', dpdx)


   else:
      with open('u-iter.dat','ab') as f:
        np.savetxt(f, np.c_[u2d[0,3],u2d[0,11],u2d[0,22],u2d[0,38]])
      with open('k-iter.dat','ab') as f:
        np.savetxt(f, np.c_[k2d[0,3],k2d[0,11],k2d[0,22],k2d[0,38]])
   if iter%100:
      np.savetxt('force-history.dat', np.c_[xpforce,flowin])

   return su2d,sp2d

def modify_v(su2d,sp2d):

   return su2d,sp2d

def modify_p(su2d,sp2d):

   return su2d,sp2d

def modify_k(su2d,sp2d):

# we know that the convection and diffusion term in the x direction are zero
   aw2d=np.zeros((ni,nj))
   ae2d=np.zeros((ni,nj))

   return su2d,sp2d

def modify_om(su2d,sp2d):

# we know that the convection and diffusion term in the x direction are zero
   aw2d=np.zeros((ni,nj))
   ae2d=np.zeros((ni,nj))

   return su2d,sp2d

def modify_outlet(convw):

   return convw

def fix_omega():

   return aw2d,ae2d,as2d,an2d,ap2d,su2d,sp2d

def modify_vis(vis2d):

   return vis2d


def fix_k():

   return aw2d,ae2d,as2d,an2d,ap2d,su2d,sp2d
